> ## Documentation Index
> Fetch the complete documentation index at: https://docs.edgeimpulse.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Get impulse blocks

> Lists all possible blocks that can be used in the impulse, including any additional information required by the EON tuner that the getImpulseBlocks endpoint does not return



## OpenAPI

````yaml /.assets/openapi.yaml get /api/{projectId}/optimize/all-blocks
openapi: 3.0.0
info:
  title: Edge Impulse API
  version: 1.0.0
servers:
  - url: https://studio.edgeimpulse.com/v1
security:
  - ApiKeyAuthentication: []
  - JWTAuthentication: []
  - JWTHttpHeaderAuthentication: []
  - OAuth2: []
paths:
  /api/{projectId}/optimize/all-blocks:
    get:
      tags:
        - Optimization
      summary: Get impulse blocks
      description: >-
        Lists all possible blocks that can be used in the impulse, including any
        additional information required by the EON tuner that the
        getImpulseBlocks endpoint does not return
      operationId: getAllBlocks
      parameters:
        - $ref: '#/components/parameters/ProjectIdParameter'
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AllBlocksResponse'
components:
  parameters:
    ProjectIdParameter:
      name: projectId
      in: path
      required: true
      description: Project ID
      schema:
        type: integer
  schemas:
    AllBlocksResponse:
      allOf:
        - $ref: '#/components/schemas/GenericApiResponse'
        - type: object
          required:
            - input
            - dsp
            - learn
          properties:
            input:
              type: array
              items:
                $ref: '#/components/schemas/TunerBlock'
            dsp:
              type: array
              items:
                $ref: '#/components/schemas/TunerBlock'
            learn:
              type: array
              items:
                $ref: '#/components/schemas/TunerBlock'
    GenericApiResponse:
      type: object
      required:
        - success
      properties:
        success:
          type: boolean
          description: Whether the operation succeeded
        error:
          type: string
          description: Optional error description (set if 'success' was false)
    TunerBlock:
      type: object
      required:
        - type
        - title
        - blockType
      properties:
        type:
          type: string
        title:
          type: string
        blockType:
          $ref: '#/components/schemas/BlockType'
        author:
          type: string
        description:
          type: string
        name:
          type: string
        recommended:
          type: boolean
        organizationModelId:
          type: number
        params:
          type: object
          additionalProperties:
            $ref: '#/components/schemas/DSPGroupItem'
        defaultConfig:
          type: object
        variants:
          type: object
          additionalProperties:
            type: object
            properties:
              title:
                type: string
              key:
                type: string
              regression:
                type: boolean
              objectDetection:
                type: boolean
              projectDataType:
                type: string
              searchSpaceTemplates:
                type: array
                items:
                  type: object
                  properties:
                    template:
                      type: string
                    group:
                      type: string
                    blocks:
                      type: object
                      properties:
                        input:
                          type: object
                          properties:
                            type:
                              type: string
                            variant:
                              type: string
                            params:
                              type: object
                        dsp:
                          type: object
                          properties:
                            type:
                              type: string
                            variant:
                              type: string
                            params:
                              type: object
                        learn:
                          type: object
                          properties:
                            type:
                              type: string
                            variant:
                              type: string
                            params:
                              type: object
              params:
                type: object
                additionalProperties:
                  type: array
                  items:
                    type: object
    BlockType:
      type: string
      enum:
        - official
        - personal
        - enterprise
        - community
    DSPGroupItem:
      type: object
      required:
        - name
        - type
        - param
        - defaultValue
        - readonly
        - shouldShow
        - required
        - showClickToSet
      properties:
        name:
          type: string
          example: Scale axes
        value:
          type: string
        defaultValue:
          type: string
        type:
          type: string
          example: text
        help:
          type: string
          example: Divide axes by this number
        param:
          type: string
          example: scale-axes
        selectOptions:
          type: array
          items:
            type: object
            properties:
              value:
                type: string
                description: >-
                  What is the string that will be set if this option is
                  selected?
              selected:
                type: boolean
              optionLabel:
                type: string
                description: >-
                  What is the label that will be shown to the user for this
                  option?
              priority:
                type: number
                description: >-
                  The following options are optional.  See Learn Block Auto
                  Config in Notion. Higher priority will get chosen based on
                  limits below.
              romEstimate:
                type: number
                description: >-
                  Estimated ROM footprint for this choice.  Will be tested
                  against ROM budget in Studio.
              needsOps:
                type: array
                items:
                  type: string
                  description: ML operator needed by this choice.
              needsFeatures:
                type: array
                items:
                  type: string
                  description: Feature needed by this choice. (non op related)
        readonly:
          type: boolean
        shouldShow:
          type: boolean
        showIf:
          type: object
          required:
            - parameter
            - operator
            - value
          properties:
            parameter:
              type: string
            operator:
              type: string
              enum:
                - eq
                - neq
            value:
              type: string
        invalidText:
          type: string
        section:
          type: string
          description: Interface section to render parameter in.
          enum:
            - advanced
            - augmentation
            - modelProfiling
        multiline:
          type: boolean
          description: Only valid for type "string". Will render a multiline text area.
        required:
          type: boolean
        hint:
          type: string
          description: If set, shows a hint below the input.
        placeholder:
          type: string
          description: >-
            Sets the placeholder text on the input element (for types "string",
            "int", "float" and "secret")
        showClickToSet:
          type: boolean
          description: If enabled, render a disabled input element with 'Click to set'
        valid:
          type: array
          items:
            type: object
          description: Valid values for parameter.
        items:
          type: object
          description: Recursive definition for items of a parameter with type 'array'.
        properties:
          type: object
          description: Recursive definition for a parameter with type 'object'.
        minVal:
          type: number
          description: Minimum value for parameters of type 'int' or 'float'.
        maxVal:
          type: number
          description: Maximum value for parameters of type 'int' or 'float'.
  securitySchemes:
    ApiKeyAuthentication:
      type: apiKey
      in: header
      name: x-api-key
    JWTAuthentication:
      type: apiKey
      in: cookie
      name: jwt
    JWTHttpHeaderAuthentication:
      type: apiKey
      in: header
      name: x-jwt-token
    OAuth2:
      type: oauth2
      flows:
        authorizationCode:
          authorizationUrl: /v1/oauth/authorize
          tokenUrl: /v1/oauth/token
          scopes:
            openid: Access to basic profile information
            email: Access to email address
            profile: Access to full profile information
        implicit:
          authorizationUrl: /v1/oauth/authorize
          scopes:
            openid: Access to basic profile information
            email: Access to email address
            profile: Access to full profile information
        password:
          tokenUrl: /v1/oauth/token
          scopes:
            openid: Access to basic profile information
            email: Access to email address
            profile: Access to full profile information
        clientCredentials:
          tokenUrl: /v1/oauth/token
          scopes:
            openid: Access to basic profile information
            email: Access to email address
            profile: Access to full profile information

````